//------------------------------------------------------------------
//
//------------------------------------------------------------------

#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"


#property indicator_chart_window
#property indicator_buffers 5

#property indicator_color1   clrSpringGreen
#property indicator_color2  clrGray
#property indicator_color3  clrGray

#property indicator_width1   2


#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT





//
enum ARROWS
{
   OnFirst, // All break arrows
   OnAll,  // Only first break
  
};
//


enum enTimeFrames
{
   tf_cu  = PERIOD_CURRENT, // Current time frame
   tf_m1  = PERIOD_M1,      // 1 minute
   tf_m5  = PERIOD_M5,      // 5 minutes
   tf_m15 = PERIOD_M15,     // 15 minutes
   tf_m30 = PERIOD_M30,     // 30 minutes
   tf_h1  = PERIOD_H1,      // 1 hour
   tf_h4  = PERIOD_H4,      // 4 hours
   tf_d1  = PERIOD_D1,      // Daily
   tf_w1  = PERIOD_W1,      // Weekly
   tf_mn1 = PERIOD_MN1,     // Monthly
   tf_n1  = -1,             // First higher time frame
   tf_n2  = -2,             // Second higher time frame
   tf_n3  = -3              // Third higher time frame
};


//
//
extern enTimeFrames    TimeFrame          = tf_cu;      // Timeframe to use
extern int                BandsLength          = 20;              // Bands period
extern double             BandsDeviation       = 2.0;             // Bands deviation
input ENUM_APPLIED_PRICE AppliedPrice=PRICE_CLOSE;  //Bands Applied Price
extern ARROWS         arr    = OnAll;             // Arrows all-first? 
extern bool            Interpolate     = true;           // Interpolate in mtf mode
input bool             alertsOn        = false;           // Alerts on true/false?
input bool             alertsOnCurrent = false;          // Alerts on (still opened) bar true/false?
input bool             alertsMessage   = true;           // Alerts message true/false?
input bool             alertsSound     = true;          // Alerts sound true/false?
input bool             alertsNotify    = false;          // Alerts push notification true/false?
input bool             alertsEmail     = false;          // Alerts email true/false?
input string           soundFile       = "alert2.wav";   // Sound file
extern bool              ShowArrows = true;            // Arrows are visible?
input bool             ArrowOnFirst    = true;             // Arrow on first bars true/false
input int              UpArrowSize     = 1;                // Up Arrow size
input int              DnArrowSize     = 1;                // Down Arrow size
input int              UpArrowCode     = 236;              // Up Arrow code
input int              DnArrowCode     = 238;              // Down arrow code
input double           UpArrowGap      = 0.5;              // Up Arrow gap        
input double           DnArrowGap      = 0.5;              // Dn Arrow gap
input color            UpArrowColor    = clrLimeGreen;     // Up Arrow Color
input color            DnArrowColor    = clrOrange;        // Down Arrow Color

//template code 
extern string             button_note1          = "------------------------------";
extern int                btn_Subwindow = 0;
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; 
extern string             btn_text              = "BB";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;                            
extern color              btn_text_ON_color     = clrLime;
extern color              btn_text_OFF_color    = clrRed;
extern string             btn_pressed           = "BB OFF";            
extern string             btn_unpressed         = "BB ON";
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 200;                                 
extern int                button_y              = 0;                                   
extern int                btn_Width             = 65;                                 
extern int                btn_Height            = 20;                                
extern string             soundBT               = "tick.wav";  
extern string             button_note2          = "------------------------------";

bool                      show_data             = true;
string IndicatorName, IndicatorObjPrefix ,buttonId ;


//
double trend[],count[];
double ma[],upBand[],dnBand[],upa[],dna[];
string indicatorFileName;
#define _mtfCall(_buff,_ind) iCustom(NULL,TimeFrame,indicatorFileName,0,BandsLength,BandsDeviation,AppliedPrice,arr,Interpolate,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,ShowArrows,ArrowOnFirst,UpArrowSize,DnArrowSize,UpArrowCode,DnArrowCode,UpArrowGap,DnArrowGap,UpArrowColor,DnArrowColor,button_note1,btn_Subwindow,btn_corner,btn_text,btn_Font,btn_FontSize,btn_text_ON_color,btn_text_OFF_color,btn_pressed,btn_unpressed,btn_background_color,btn_border_color,button_x,button_y,btn_Width,btn_Height,soundBT,button_note2,_buff,_ind)
//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//template code 
string GenerateIndicatorName(const string target)
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//template code 

int init()
{

      
	
   IndicatorBuffers(7);
    SetIndexBuffer(0,ma,INDICATOR_DATA); SetIndexStyle(0,DRAW_LINE);
    SetIndexBuffer(1,upBand,INDICATOR_DATA); SetIndexStyle(1,DRAW_LINE);
    SetIndexBuffer(2,dnBand,INDICATOR_DATA);SetIndexStyle(2,DRAW_LINE);
  
    SetIndexBuffer(3, upa);   SetIndexStyle(3,ShowArrows ? DRAW_ARROW :  DRAW_NONE,EMPTY,UpArrowSize,UpArrowColor); SetIndexArrow(3,UpArrowCode);
    SetIndexBuffer(4, dna);   SetIndexStyle(4,ShowArrows ? DRAW_ARROW :  DRAW_NONE,EMPTY,DnArrowSize,DnArrowColor); SetIndexArrow(4,DnArrowCode);
    
    SetIndexBuffer(5,trend);
    SetIndexBuffer(6,count);
   
   
   
   indicatorFileName = WindowExpertName();
   TimeFrame         = (enTimeFrames)timeFrameValue(TimeFrame);
   IndicatorShortName(timeFrameToString(TimeFrame)+" 2 alma  ("+BandsLength+")");
   
   //template code 
   IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(WindowExpertName());
   IndicatorDigits(Digits);
      double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
   show_data = val != 0;

   ChartSetInteger(ChartID(), CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix+btn_text;
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_XDISTANCE, button_x);
   
   
   
  return(0);
}


//template code 
void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (ChartID(),buttonID);
      ObjectCreate (ChartID(),buttonID,OBJ_BUTTON,btn_Subwindow,0,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (ChartID(),buttonID,OBJPROP_FONT,font);
      ObjectSetString (ChartID(),buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YDISTANCE,9999);
}
//template code    


int deinit()
{

 ObjectsDeleteAll(0,"BB");
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);
  

return(0);
}

 bool recalc = true;
 void handleButtonClicks()
{
   if (ObjectGetInteger(ChartID(), buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(ChartID(), buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
void OnChartEvent(const int id, 
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
   if (id==CHARTEVENT_OBJECT_CLICK && ObjectGet(sparam,OBJPROP_TYPE)==OBJ_BUTTON)
   {
   if (soundBT!="") PlaySound(soundBT);     
   }
}
//template code 


 int start()
{ 
//template code 
   handleButtonClicks();
   recalc = false;
   
   start2();
  
   
        SetIndexStyle(0,DRAW_LINE);
        SetIndexStyle(1,DRAW_LINE);
        SetIndexStyle(2,DRAW_LINE);
        SetIndexStyle(3,ShowArrows ? DRAW_ARROW :  DRAW_NONE,EMPTY,UpArrowSize,UpArrowColor); SetIndexArrow(3,UpArrowCode);
        SetIndexStyle(4,ShowArrows ? DRAW_ARROW :  DRAW_NONE,EMPTY,DnArrowSize,DnArrowColor); SetIndexArrow(4,DnArrowCode);
      
   
   if (show_data)
      {
      ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color);
      ObjectSetString(ChartID(),buttonId,OBJPROP_TEXT,btn_unpressed);
      }
      else
      {
      ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
      ObjectSetString(ChartID(),buttonId,OBJPROP_TEXT,btn_pressed);
      SetIndexStyle(0,DRAW_NONE);
        SetIndexStyle(1,DRAW_NONE);
        SetIndexStyle(2,DRAW_NONE);
        SetIndexStyle(3,DRAW_NONE);
        SetIndexStyle(4,DRAW_NONE);
      
   
      //template code     
      }
       return(0);
      }
      
       int start2()
  {
   

   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars - counted_bars,Bars-1);  count[0] = limit;
           
   
           if (TimeFrame!=_Period)
           {
               limit = (int)MathMax(limit,MathMin(Bars-1,_mtfCall(6,0)*TimeFrame/_Period));
           
             
               for (int i=limit;i>=0;i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                  int x = y;
                if (ArrowOnFirst)
                      {  if (i<Bars-1) x = iBarShift(NULL,TimeFrame,Time[i+1]);               }
                else  {  if (i>0)      x = iBarShift(NULL,TimeFrame,Time[i-1]); else x = -1;  }
                
                  ma[i]    = _mtfCall(0,y);
                  upBand[i]    = _mtfCall(1,y);
                  dnBand[i]  = _mtfCall(2,y);
                  trend[i]  = _mtfCall(5,y);
                  upa[i] = dna[i]  = EMPTY_VALUE;
               
                if (x!=y)
                     {
                       upa[i] = _mtfCall(3,y);
                       dna[i] = _mtfCall(4,y);
                     }     
                  //
                  //
      
                  if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                      #define _interpolate(buff) buff[i+k] = buff[i]+(buff[i+n]-buff[i])*k/n
                      int n,k; datetime time = iTime(NULL,TimeFrame,y);
                         for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
                         for(k = 1; k<n && (i+n)<Bars && (i+k)<Bars; k++)
                         {
                         _interpolate(ma);
                         _interpolate(upBand);
                         _interpolate(dnBand);
                   
                        
                         }
               }
            
                 
                 
                               
            return(0);
      }
   //
   //
   //
   //
   //
 
 
   
      for( i = limit; i >= 0 ; i--)
      {
      
       
         ma[i]       = iBands(NULL,0,BandsLength,BandsDeviation,0,AppliedPrice,MODE_MAIN,i);
         upBand[i]   = iBands(NULL,0,BandsLength,BandsDeviation,0,AppliedPrice,MODE_UPPER,i);
         dnBand[i]   = iBands(NULL,0,BandsLength,BandsDeviation,0,AppliedPrice,MODE_LOWER,i);
         
         switch (arr)
        {
         case OnFirst:
      trend[i] = (i<Bars-1) ? (Close[i]>upBand[i]) ? 1 : (Close[i]<dnBand[i]) ? -1  : trend[i+1]  : 0;
       break;
         case OnAll:  
        trend[i] = (Close[i]>upBand[i]) ? 1 : (Close[i]<dnBand[i]) ? -1   : 0;  
         break;
         }                
         
         
         
        if (i<Bars-1 && trend[i]!=trend[i+1])
      {
         if (trend[i] ==  1) upa[i] = Low[i] -iATR(NULL,0,15,i)*UpArrowGap;
         if (trend[i] == -1) dna[i] =High[i]+iATR(NULL,0,15,i)*DnArrowGap;
      } 
      
     
   }
           
       
      
     if (alertsOn)
   {
      int whichBar = (alertsOnCurrent) ? 0 : 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
            if (trend[whichBar]== 1 ) doAlert("  signal up");
            if (trend[whichBar]== -1 ) doAlert("  signal down");       
      }  
      }       
       
   return(0);
}




//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//





string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

 int timeFrameValue(int _tf)
{
   int add  = (_tf>=0) ? 0 : MathAbs(_tf);
   if (add != 0) _tf = _Period;
   int size = ArraySize(iTfTable); 
      int i =0; for (;i<size; i++) if (iTfTable[i]==_tf) break;
                                   if (i==size) return(_Period);
                                                return(iTfTable[(int)MathMin(i+add,size-1)]);
}

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message = timeFrameToString(_Period)+" "+_Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+"  BB  "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(_Symbol+"  BB  ",message);
             if (alertsSound)   PlaySound(soundFile);
      }
}